precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform highp float scale;
void main() {
    vec2 textureCoordinate1 = vec2((scale - 1.0) * 0.5 + textureCoordinate.x / scale, (scale - 1.0) * 0.5 + textureCoordinate.y / scale);
    vec4 textureColor1 = texture2D(inputImageTexture, textureCoordinate1);
    vec4 flashingColor1 = texture2D(inputImageTexture, textureCoordinate1 + vec2(-0.09 * (scale - 1.0), -0.09 * (scale - 1.0)));
    vec4 flashingColor2 = texture2D(inputImageTexture, textureCoordinate1 + vec2(-0.17 * (scale - 1.0), -0.16 * (scale - 1.0)));
    vec3 blendColor1 = vec3(flashingColor1.r, textureColor1.g, textureColor1.b);
    vec3 blendColor2 = vec3(flashingColor1.r, flashingColor2.g, flashingColor1.b);
    gl_FragColor = vec4(blendColor2, textureColor1.a);
}