#ifndef   TEXCOORDP
#define   TEXCOORDP highp
#endif // TEXCOORDP

#ifndef   IS_EXTERNAL_TEXTURE
#define   IS_EXTERNAL_TEXTURE 0
#endif // IS_EXTERNAL_TEXTURE

#if IS_EXTERNAL_TEXTURE
#extension GL_OES_EGL_image_external: require
#define SAMPLER_TEXTURE_sImage samplerExternalOES
#else // IS_EXTERNAL_TEXTURE
#define SAMPLER_TEXTURE_sImage sampler2D
#endif // IS_EXTERNAL_TEXTURE

varying TEXCOORDP vec2 vTexCoord;

#ifdef    RETROVK_VERTEX_SHADER

precision highp float;

attribute vec4 aPosition;
attribute vec2 aTexCoord;

uniform mat4 uImageMatrix;

void main()
{
  gl_Position = aPosition;

  vTexCoord = (uImageMatrix * vec4(aTexCoord, 0, 1)).xy;
}

#endif // RETROVK_VERTEX_SHADER


#ifdef    RETROVK_FRAGMENT_SHADER

precision mediump float;

uniform SAMPLER_TEXTURE_sImage sImage;

void main()
{
  gl_FragColor = texture2D(sImage, vTexCoord);
}

#endif // RETROVK_FRAGMENT_SHADER
